package org.vtokarev.controller;

import org.vtokarev.domain.*;
import org.vtokarev.service.RoomClassService;
import org.vtokarev.service.RoomRequestService;
import org.vtokarev.service.RoomService;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;
import java.time.Instant;
import java.time.LocalDate;
import java.util.List;
import java.util.stream.IntStream;

/**
 * The {@code CreateRequestServlet} class implements {@code doGet} method that processes GET {@code createRequest} requests generated by users with GUEST role.
 * In the {@code doGet} method, it collects the necessary data from the GUEST request and forward control to {@code createRequest.jsp} view for further request processing.
 * In the {@code doPost} method, it uses the collected data and create request then back to the {@code requestList}.
 *
 * @author Vyacheslav Tokarev
 */
@WebServlet(urlPatterns = "/createRequest", name = "createRequestServlet")
public class CreateRequestServlet extends HttpServlet {

    private RoomRequestService roomRequestService;

    private RoomClassService roomClassService;

    private RoomService roomService;

    @Override
    public void init(ServletConfig config) throws ServletException {
        roomRequestService = (RoomRequestService) config.getServletContext().getAttribute("app/RoomRequestService");
        roomClassService = (RoomClassService) config.getServletContext().getAttribute("app/RoomClassService");
        roomService = (RoomService) config.getServletContext().getAttribute("app/RoomService");
    }

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        int capacity = roomService.getMaxCapacity();
        int[] capacities = IntStream.range(1, capacity + 1).toArray();

        List<RoomClass> roomClasses = roomClassService.getAll();

        req.setAttribute("capacities", capacities);
        req.setAttribute("roomClasses", roomClasses);
        req.getRequestDispatcher("/WEB-INF/jsp/createRequest.jsp").forward(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws IOException {
        LocalDate checkin = LocalDate.parse(req.getParameter("checkin"));
        LocalDate checkout = LocalDate.parse(req.getParameter("checkout"));

        int personsNumber = Integer.parseInt(req.getParameter("personsNumber"));
        int roomClassId = Integer.parseInt(req.getParameter("roomClass"));
        String guestNotes = req.getParameter("guestNotes");

        long userId = ((User)req.getSession().getAttribute("user")).getId();
        String errorMessage = roomRequestService.getRegistrationErrorMessage(checkin, checkout, roomClassId, personsNumber);

        if (errorMessage.isBlank()) {
            RoomRequest roomRequest = new RoomRequest();
            roomRequest.setStatus(RoomRequestStatus.NEW);
            roomRequest.setCheckin(checkin);
            roomRequest.setCheckout(checkout);
            roomRequest.setRoomClassId(roomClassId);
            roomRequest.setPersonsNumber(personsNumber);
            roomRequest.setGuestNotes(guestNotes);
            roomRequest.setUserId(userId);
            roomRequest.setRegDate(Instant.now());
            roomRequestService.create(roomRequest);
            resp.sendRedirect("requestList");
        } else {
            String redirectString = "createRequest?prg=yes" +
                    "&checkin=" + checkin +
                    "&checkout=" + checkout +
                    "&personsNumber=" + personsNumber +
                    "&roomClassId=" + roomClassId +
                    "&guestNotes=" + URLEncoder.encode(guestNotes, StandardCharsets.UTF_8) +
                    "&errorMessage=" + URLEncoder.encode(errorMessage, StandardCharsets.UTF_8);
            resp.sendRedirect(redirectString);
        }
    }
}